Index: /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1158)
@@ -2313,74 +2407,199 @@
       {
          StdOStringStream oss;
-
+         bool createInstantAxis=false ;
+         bool createCenteredAxis=false ;
+         bool createTimeCounterAxis=false ;
+         
          if (field->getOperationTimeType() == func::CFunctor::once) return ;
 
-//         oss << "time_" << field->operation.getValue()
-//             << "_" << field->getRelFile()->output_freq.getValue();
-
-//         StdString axisid = oss.str();
-//         if (field->getOperationTimeType() == func::CFunctor::centered) axisid="time_centered" ;
-//         else if (field->getOperationTimeType() == func::CFunctor::instant) axisid="time_instant" ;
-
-         StdString axisid("time_centered") ;
-         StdString axisBoundId("time_centered_bounds");
+
+         StdString axisId ;
+         StdString axisBoundId;
          StdString timeid(getTimeCounterName());
          StdString timeBoundId("axis_nbounds");
 
-         if (field->getOperationTimeType() == func::CFunctor::instant)
-         {
-            axisid = "time_instant";
-            axisBoundId = "time_instant_bounds";
-         }
-
+         StdString strTimeUnits ;
+         if (!field->file->time_units.isEmpty() && field->file->time_units==CFile::time_units_attr::days) strTimeUnits="days since " ;
+         else  strTimeUnits="seconds since " ;
+ 
+         if (field->getOperationTimeType() == func::CFunctor::instant) field->hasTimeInstant = true;
+         if (field->getOperationTimeType() == func::CFunctor::centered) field->hasTimeCentered = true;
+
+
+         if (field->file->time_counter.isEmpty())
+         {
+           if (timeCounterType==none) createTimeCounterAxis=true ;
+           if (field->hasTimeCentered)
+           {
+             timeCounterType=centered ;
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (timeCounterType==none) timeCounterType=instant ;
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::instant)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (timeCounterType==none) createTimeCounterAxis=true ;
+             timeCounterType=instant ;
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::centered)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (timeCounterType==none) createTimeCounterAxis=true ;
+             timeCounterType=centered ;
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::instant_exclusive)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (timeCounterType==none) createTimeCounterAxis=true ;
+             timeCounterType=instant ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::centered_exclusive)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (timeCounterType==none) createTimeCounterAxis=true ;
+             timeCounterType=centered ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::exclusive)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (timeCounterType==none) createTimeCounterAxis=true ;
+             if (timeCounterType==instant) createInstantAxis=true ;
+             timeCounterType=centered ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (timeCounterType==none)
+             {
+               createTimeCounterAxis=true ;
+               timeCounterType=instant ;
+             }
+             if (timeCounterType==centered)
+             {
+               if (!hasTimeInstant) createInstantAxis=true ;
+             }
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::none)
+         {
+           if (field->hasTimeCentered)
+           {
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         else if (field->file->time_counter==CFile::time_counter_attr::record)
+         {
+           if (timeCounterType==none) createTimeCounterAxis=true ;
+           timeCounterType=record ;
+           if (field->hasTimeCentered)
+           {
+             if (!hasTimeCentered) createCenteredAxis=true ;
+           }
+           if (field->hasTimeInstant)
+           {
+             if (!hasTimeInstant) createInstantAxis=true ;
+           }
+         }
+         
+         if (createInstantAxis)
+         {
+           axisId="time_instant" ;
+           axisBoundId="time_instant_bounds";
+           hasTimeInstant=true ;
+         }
+
+         if (createCenteredAxis)
+         {
+           axisId="time_centered" ;
+           axisBoundId="time_centered_bounds";
+           hasTimeCentered=true ;
+         }
+
+         
          try
          {
-          // Adding time_instant or time_centered
-           std::vector<StdString> dims;
-           dims.push_back(timeid);
-           if (!SuperClassWriter::varExist(axisid))
-           {
-              SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
-
-              CDate timeOrigin=cal->getTimeOrigin() ;
-              StdOStringStream oss2;
-  //            oss2<<initDate.getYear()<<"-"<<initDate.getMonth()<<"-"<<initDate.getDay()<<" "
-  //                <<initDate.getHour()<<"-"<<initDate.getMinute()<<"-"<<initDate.getSecond() ;
-              StdString strInitdate=oss2.str() ;
-              StdString strTimeOrigin=timeOrigin.toString() ;
-              this->writeTimeAxisAttributes
-                 (axisid, cal->getType(),
-                  StdString("seconds since ").append(strTimeOrigin),
-                  strTimeOrigin, axisBoundId);
-           }
-
-           // Adding time_instant_bounds or time_centered_bounds variables
-           if (!SuperClassWriter::varExist(axisBoundId))
-           {
-              dims.clear() ;
+            std::vector<StdString> dims;
+            
+            if (createInstantAxis || createCenteredAxis)
+            {
+              // Adding time_instant or time_centered
               dims.push_back(timeid);
-              dims.push_back(timeBoundId);
-              SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
-           }
-
-           if (field->file->time_counter != CFile::time_counter_attr::none)
+              if (!SuperClassWriter::varExist(axisId))
+              {
+                SuperClassWriter::addVariable(axisId, NC_DOUBLE, dims);
+
+                CDate timeOrigin=cal->getTimeOrigin() ;
+                StdOStringStream oss2;
+                StdString strInitdate=oss2.str() ;
+                StdString strTimeOrigin=timeOrigin.toString() ;
+                this->writeTimeAxisAttributes(axisId, cal->getType(),strTimeUnits+strTimeOrigin,
+                                              strTimeOrigin, axisBoundId);
+             }
+
+             // Adding time_instant_bounds or time_centered_bounds variables
+             if (!SuperClassWriter::varExist(axisBoundId))
+             {
+                dims.clear() ;
+                dims.push_back(timeid);
+                dims.push_back(timeBoundId);
+                SuperClassWriter::addVariable(axisBoundId, NC_DOUBLE, dims);
+             }
+           }
+
+           if (createTimeCounterAxis)
            {
              // Adding time_counter
-             axisid = getTimeCounterName();
+             axisId = getTimeCounterName();
              axisBoundId = getTimeCounterName() + "_bounds";
              dims.clear();
              dims.push_back(timeid);
-             if (!SuperClassWriter::varExist(axisid))
+             if (!SuperClassWriter::varExist(axisId))
              {
-                SuperClassWriter::addVariable(axisid, NC_DOUBLE, dims);
-                SuperClassWriter::addAttribute("axis", string("T"), &axisid);
-
-                if (field->file->time_counter != CFile::time_counter_attr::record)
+                SuperClassWriter::addVariable(axisId, NC_DOUBLE, dims);
+                SuperClassWriter::addAttribute("axis", string("T"), &axisId);
+
+                if (field->file->time_counter.isEmpty() || 
+                   (field->file->time_counter != CFile::time_counter_attr::record))
                 {
                   CDate timeOrigin = cal->getTimeOrigin();
                   StdString strTimeOrigin = timeOrigin.toString();
 
-                  this->writeTimeAxisAttributes(axisid, cal->getType(),
-                                                StdString("seconds since ").append(strTimeOrigin),
+                  this->writeTimeAxisAttributes(axisId, cal->getType(),
+                                                strTimeUnits+strTimeOrigin,
                                                 strTimeOrigin, axisBoundId);
                 }
@@ -2388,5 +2607,5 @@
 
              // Adding time_counter_bound dimension
-             if (field->file->time_counter != CFile::time_counter_attr::record)
+             if (field->file->time_counter.isEmpty() || (field->file->time_counter != CFile::time_counter_attr::record))
              {
                 if (!SuperClassWriter::varExist(axisBoundId))
@@ -2563,6 +2782,18 @@
            SuperClassWriter::addAttribute("title"      , description);
            SuperClassWriter::addAttribute("Conventions", conventions);
-           SuperClassWriter::addAttribute("production" , production);
-           SuperClassWriter::addAttribute("timeStamp"  , timeStamp);
+           // SuperClassWriter::addAttribute("production" , production);
+
+           StdString timeStampStr ;
+           if (file->time_stamp_name.isEmpty()) timeStampStr="timeStamp" ;
+           else timeStampStr=file->time_stamp_name ;
+           SuperClassWriter::addAttribute(timeStampStr, timeStamp);
+
+           StdString uuidName ;
+           if (file->uuid_name.isEmpty()) uuidName="uuid" ;
+           else uuidName=file->uuid_name ;
+
+           if (file->uuid_format.isEmpty()) SuperClassWriter::addAttribute(uuidName, getUuidStr());
+           else SuperClassWriter::addAttribute(uuidName, getUuidStr(file->uuid_format));
+          
          }
          catch (CNetCdfException& e)
@@ -2616,5 +2847,5 @@
       ///--------------------------------------------------------------
 
-      StdSize CNc4DataOutput::getRecordFromTime(Time time)
+      StdSize CNc4DataOutput::getRecordFromTime(Time time, double factorUnit)
       {
         std::map<Time, StdSize>::const_iterator it = timeToRecordCache.find(time);
@@ -2622,15 +2853,17 @@
         {
           StdString timeAxisBoundsId(getTimeCounterName() + "_bounds");
-          if (!SuperClassWriter::varExist(timeAxisBoundsId))
-            timeAxisBoundsId = "time_instant_bounds";
+          if (!SuperClassWriter::varExist(timeAxisBoundsId)) timeAxisBoundsId = "time_centered_bounds";
+          if (!SuperClassWriter::varExist(timeAxisBoundsId)) timeAxisBoundsId = "time_instant_bounds";
 
           CArray<double,2> timeAxisBounds;
-          SuperClassWriter::getTimeAxisBounds(timeAxisBounds, timeAxisBoundsId, isCollective);
-
+          std::vector<StdSize> dimSize(SuperClassWriter::getDimensions(timeAxisBoundsId)) ;
+          
           StdSize record = 0;
           double dtime(time);
-          for (int n = timeAxisBounds.extent(1) - 1; n >= 0; n--)
+          for (int n = dimSize[0] - 1; n >= 0; n--)
           {
-            if (timeAxisBounds(1, n) < dtime)
+            SuperClassWriter::getTimeAxisBounds(timeAxisBounds, timeAxisBoundsId, isCollective, n);
+            timeAxisBounds*=factorUnit ;
+            if (timeAxisBounds(1, 0) < dtime)
             {
               record = n + 1;
Index: /XIOS/dev/dev_olga/src/io/nc4_data_output.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/nc4_data_output.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/nc4_data_output.hpp	(revision 1158)
@@ -23,7 +23,7 @@
             /// Constructeurs ///
             CNc4DataOutput
-               (const StdString & filename, bool exist);
+               (CFile* file, const StdString & filename, bool exist);
             CNc4DataOutput
-               (const StdString & filename, bool exist, bool useClassicFormat,
+               (CFile* file, const StdString & filename, bool exist, bool useClassicFormat,
                 bool useCFConvention,
                 MPI_Comm comm_file, bool multifile, bool isCollective = true,
@@ -96,5 +96,5 @@
                                      const StdString & nav_model);
 
-            StdSize getRecordFromTime(Time time);
+            StdSize getRecordFromTime(Time time, double factorUnit);
 
          private :
@@ -123,4 +123,8 @@
             std::set<std::string> writtenAxis, writtenCompressedAxis;
             std::set<std::string> writtenScalar;
+
+            enum { none, centered, instant, record} timeCounterType ;
+            bool hasTimeInstant ;
+            bool hasTimeCentered ;
       }; // class CNc4DataOutput
 
Index: /XIOS/dev/dev_olga/src/io/netCdfInterface.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/netCdfInterface.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/netCdfInterface.cpp	(revision 1158)
@@ -967,4 +967,10 @@
 }
 
+template<>
+int CNetCdfInterface::ncGetVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, char* data)
+{
+  return nc_get_vara_text(ncid, varid, start, count, data);
+}
+
 // Some specializations of putVariableType
 template<>
@@ -984,4 +990,10 @@
 {
   return nc_put_vara_int(ncid, varid, start, count, data);
+}
+
+template<>
+int CNetCdfInterface::ncPutVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, const char* data)
+{
+  return nc_put_vara_text(ncid, varid, start, count, data);
 }
 
Index: /XIOS/dev/dev_olga/src/io/netCdfInterface_decl.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/netCdfInterface_decl.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/netCdfInterface_decl.cpp	(revision 1158)
@@ -33,5 +33,6 @@
   macroPutVar(float)
   macroPutVar(int)
-
+  macroPutVar(char)
+  
 #define macroType(type, ncType) \
   template<> nc_type CNetCdfInterface::getNcType<type>() { return ncType; }
Index: /XIOS/dev/dev_olga/src/io/netCdfInterface_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/netCdfInterface_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/netCdfInterface_impl.hpp	(revision 1158)
@@ -121,16 +121,4 @@
       inqVarName(ncid, varId, varName);
       sstr << "Unable to write data given the location id: " << ncid << " and the variable whose id: " << varId << " and name: " << varName << std::endl;
-//      if (status == NC_ENOTVAR )
-//        sstr <<   "Variable not found. "<< std::endl;
-//      else if (status == NC_EINVALCOORDS)
-//        sstr <<   "Index exceeds dimension bound. "<< std::endl;
-//      else if (status == NC_EEDGE)
-//        sstr <<   " Start+count exceeds dimension bound. "<< std::endl;
-//      else if (status == NC_ERANGE)
-//        sstr <<   " One or more of the values are out of range. "<< std::endl;
-//      else if (status == NC_EINDEFINE)
-//        sstr <<   " Operation not allowed in define mode. "<< std::endl;
-//      else if (status == NC_EBADID)
-//        sstr <<   "Bad ncid. "<< std::endl;
       throw CNetCdfException(sstr.str());
     }
Index: /XIOS/dev/dev_olga/src/io/onetcdf4.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/onetcdf4.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/onetcdf4.cpp	(revision 1158)
@@ -7,4 +7,5 @@
 #include "netCdfInterface.hpp"
 #include "netCdfException.hpp"
+#include "timer.hpp"
 
 namespace xios
@@ -55,9 +56,11 @@
          if (!append || !std::ifstream(filename.c_str()))
          {
+            CTimer::get("Files : create").resume();
             if (wmpi)
                CNetCdfInterface::createPar(filename, mode, *comm, MPI_INFO_NULL, this->ncidp);
             else
                CNetCdfInterface::create(filename, mode, this->ncidp);
-
+            CTimer::get("Files : create").suspend();
+ 
             this->appendMode = false;
          }
@@ -65,9 +68,10 @@
          {
             mode |= NC_WRITE;
+            CTimer::get("Files : open").resume();
             if (wmpi)
                CNetCdfInterface::openPar(filename, mode, *comm, MPI_INFO_NULL, this->ncidp);
             else
                CNetCdfInterface::open(filename, mode, this->ncidp);
-
+            CTimer::get("Files : open").suspend();
             this->appendMode = true;
          }
@@ -83,5 +87,7 @@
       void CONetCDF4::close()
       {
+        CTimer::get("Files : close").resume();
         CNetCdfInterface::close(this->ncidp);
+        CTimer::get("Files : close").suspend();
       }
 
@@ -247,5 +253,26 @@
       }
 
-      //---------------------------------------------------------------
+      void CONetCDF4::getTimeAxisBounds(CArray<double,2>& timeAxisBounds, const StdString& name, bool collective, size_t record)
+      {
+        int grpid = this->getCurrentGroup();
+        int varid = this->getVariable(name);
+
+        std::vector<StdSize> start(2), count(2);
+        start[0] = record;
+        count[0] = 1 ;
+        start[1] = 0;
+        count[1] = 2;
+
+        timeAxisBounds.resize(2, 1);
+
+        if (this->wmpi && collective)
+          CNetCdfInterface::varParAccess(grpid, varid, NC_COLLECTIVE);
+        if (this->wmpi && !collective)
+          CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
+
+        CNetCdfInterface::getVaraType(grpid, varid, &start[0], &count[0], timeAxisBounds.dataFirst());
+      }
+
+
 
       const CONetCDF4::CONetCDF4Path& CONetCDF4::getCurrentPath(void) const
@@ -503,9 +530,16 @@
       void CONetCDF4::writeData_(int grpid, int varid,
                                  const std::vector<StdSize>& sstart,
+                                 const std::vector<StdSize>& scount, char* data)
+      {
+          CNetCdfInterface::putVaraType(grpid, varid, &sstart[0], &scount[0], data);
+      }
+      
+      template <>
+      void CONetCDF4::writeData_(int grpid, int varid,
+                                 const std::vector<StdSize>& sstart,
                                  const std::vector<StdSize>& scount, const int* data)
       {
           CNetCdfInterface::putVaraType(grpid, varid, &sstart[0], &scount[0], data);
       }
-
       //---------------------------------------------------------------
 
@@ -528,5 +562,7 @@
 
          this->getWriteDataInfos(name, 0, array_size,  sstart, scount, NULL, NULL);
+
          this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
+
       }
 
@@ -554,15 +590,34 @@
 
          this->getWriteDataInfos(name, record, array_size,  sstart, scount, NULL, NULL);
-         if (using_netcdf_internal)
-         {
-           if (!isRoot)
-           {
-             sstart[0] = sstart[0] + 1;
-             scount[0] = 0;
-           }
-         }
          this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
        }
 
+      void CONetCDF4::writeTimeAxisDataBounds(const CArray<double, 1>& data, const StdString& name,
+                                        bool collective, StdSize record, bool isRoot)
+      {
+         int grpid = this->getCurrentGroup();
+         int varid = this->getVariable(name);
+
+         map<int,size_t>::iterator it=timeAxis.find(varid);
+         if (it == timeAxis.end()) timeAxis[varid] = record;
+         else
+         {
+           if (it->second >= record) return;
+           else it->second =record;
+         }
+
+         StdSize array_size = 1;
+         std::vector<StdSize> sstart, scount;
+
+         if (this->wmpi && collective)
+            CNetCdfInterface::varParAccess(grpid, varid, NC_COLLECTIVE);
+         if (this->wmpi && !collective)
+            CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
+
+         this->getWriteDataInfos(name, record, array_size,  sstart, scount, NULL, NULL);
+         this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
+       }
+
+
       //---------------------------------------------------------------
 
Index: /XIOS/dev/dev_olga/src/io/onetcdf4.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/onetcdf4.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/onetcdf4.hpp	(revision 1158)
@@ -71,4 +71,6 @@
             void writeTimeAxisData(const CArray<double,1>& data, const StdString& name,
                                    bool collective, StdSize record, bool Isroot);
+            void writeTimeAxisDataBounds(const CArray<double,1>& data, const StdString& name,
+                                   bool collective, StdSize record, bool Isroot);
             /// Accesseur ///
             const CONetCDF4Path& getCurrentPath(void) const;
@@ -97,5 +99,6 @@
             const StdString& getTimeCounterName(void) const { return timeCounterName; };
 
-            void getTimeAxisBounds(CArray<double,2>& timeAxisBounds, const StdString& name, bool collective);
+            void getTimeAxisBounds(CArray<double,2>& timeAxisBounds, const StdString& name, bool collective );
+            void getTimeAxisBounds(CArray<double,2>& timeAxisBounds, const StdString& name, bool collective, size_t record);
 
             bool varExist(const StdString& varname);
Index: /XIOS/dev/dev_olga/src/io/onetcdf4_decl.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/onetcdf4_decl.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/onetcdf4_decl.cpp	(revision 1158)
@@ -14,4 +14,5 @@
   macro(double, 2)
   macro(double, 3)
+  macro(StdString, 1)
  
   template void CONetCDF4::setDefaultValue<double>(const StdString & varname, const double* value) ;
Index: /XIOS/dev/dev_olga/src/io/onetcdf4_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/onetcdf4_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/io/onetcdf4_impl.hpp	(revision 1158)
@@ -4,4 +4,5 @@
 #include "onetcdf4.hpp"
 #include "netCdfInterface.hpp"
+#include "timer.hpp"
 
 namespace xios
@@ -23,6 +24,9 @@
     CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
 
+    CTimer::get("Files : get data infos").resume();
     this->getWriteDataInfos
     (name, record, array_size,  sstart, scount, start, count);
+    CTimer::get("Files : get data infos").suspend();
+
     if (data.numElements() != array_size)
     {
@@ -34,4 +38,46 @@
 
     this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
+  }
+
+  template <>
+  void CONetCDF4::writeData(const CArray<StdString, 1>& data, const StdString & name,
+                            bool collective, StdSize record,
+                            const std::vector<StdSize> * start,
+                            const std::vector<StdSize> * count)
+  {
+    int grpid = this->getCurrentGroup();
+    int varid = this->getVariable(name);
+    StdSize array_size = 1;
+    std::vector<StdSize> sstart, scount;
+
+    if (this->wmpi && collective)
+    CNetCdfInterface::varParAccess(grpid, varid, NC_COLLECTIVE);
+    if (this->wmpi && !collective)
+    CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
+
+    CTimer::get("CONetCDF4::writeData getWriteDataInfos").resume();
+    this->getWriteDataInfos(name, record, array_size,  sstart, scount, start, count);
+    CTimer::get("CONetCDF4::writeData getWriteDataInfos").suspend();
+ 
+    if (data.numElements()*stringArrayLen != array_size)
+    {
+      ERROR("CONetCDF4::writeData(...)",
+      << "[ input array size = "  << data.numElements()
+      << ", intern array size = " << array_size
+      << " ] Invalid input data !" );
+    }
+    char* ArrayStr ;
+    char *PtrArrayStr ;
+    PtrArrayStr=ArrayStr=new char[data.numElements()*stringArrayLen] ;
+    Array<StdString,1>::const_iterator it, itb=data.begin(), ite=data.end() ;
+    for(it=itb;it!=ite;++it,PtrArrayStr+=stringArrayLen)
+    {
+      it->copy(PtrArrayStr,it->size()) ;
+      PtrArrayStr[it->size()]='\0' ;
+    }
+    CTimer::get("CONetCDF4::writeData writeData_").resume();
+    this->writeData_(grpid, varid, sstart, scount, ArrayStr);
+    CTimer::get("CONetCDF4::writeData writeData_").suspend();
+    delete [] ArrayStr ;
   }
 
Index: /XIOS/dev/dev_olga/src/memtrack.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/memtrack.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/memtrack.cpp	(revision 1158)
@@ -52,4 +52,7 @@
 {
   void addr2line(const char *file_name, char** addr, int naddr) ;
+#ifdef XIOS_MEMTRACK_LIGHT
+  void addr2line(const char *file_name, char** addr, int naddr) {} 
+#endif
 }
 /* ------------------------------------------------------------ */
@@ -59,4 +62,9 @@
 namespace MemTrack
 {
+    size_t currentMemorySize=0 ;
+    size_t maxMemorySize=0 ; 
+
+    size_t getCurrentMemorySize(void) {return currentMemorySize; }
+    size_t getMaxMemorySize(void) {return maxMemorySize ; }
 
     /* ------------------------------------------------------------ */
@@ -375,4 +383,7 @@
         // Get the offset to the user chunk and return it.
         UserChunk *pUser = GetUserAddress(pProlog);
+
+        currentMemorySize += size ;
+        if (currentMemorySize>maxMemorySize) maxMemorySize=currentMemorySize ;
         
         return pUser;
@@ -400,4 +411,5 @@
         // Unlink the block header from the list and destroy it.
         BlockHeader *pBlockHeader = GetHeaderAddress(pProlog);
+        currentMemorySize-=pBlockHeader->GetRequestedSize();
         BlockHeader::RemoveNode(pBlockHeader);
         pBlockHeader->~BlockHeader();
Index: /XIOS/dev/dev_olga/src/memtrack.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/memtrack.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/memtrack.hpp	(revision 1158)
@@ -61,5 +61,6 @@
     void TrackDumpBlocks();
     void TrackListMemoryUsage();
-
+    size_t getCurrentMemorySize(void) ;
+    size_t getMaxMemorySize(void) ;
     /* ---------------------------------------- operator * (MemStamp, ptr) */
 
